import { Category } from "./enums";

interface DamageLogger {
  (reason: string): void;
}

interface Book {
  author: string,
  available: boolean,
  category: Category;
  id: number,
  pages?: number,
  title: string,

  markDamaged?: DamageLogger,
}

interface Person {
  name: string;
  email: string;
}

interface Author extends Person {
  numBooksPublished: number;
}

interface Librarian extends Person {
  department: string,
  assistCustomer: (custName: string) => void,
}

export {
  Author,
  Book,
  DamageLogger,
  Librarian,
}
